## coccinelle 1.1.1.deb

=== ctl/Makefile ===
LIBRARY=ctl

include ../Makefile.library

=== debian/Makefile ===

all:
	debuild -S

binary:
	debuild -uc -us

=== docs/Makefile ===
SUBDIR=manual

.PHONY: all clean distclean spatch.1

ifneq ($(MAKECMDGOALS),distclean)
include ../Makefile.config
-include ../Makefile.local
endif

all: spatch.1
	$(MAKE) -C $(SUBDIR) $@

distclean:
	$(MAKE) -C manual distclean
	rm -f spatch.1
	rm -rf ./html
	rm -rf ./man

clean:
	$(MAKE) -C $(SUBDIR) $@

include ../Makefile.common

=== extra/Makefile ===
LIBRARY=extra

include ../Makefile.library

=== parsing_c/Makefile ===
LIBRARY=parsing_c

include ../Makefile.library

=== popl/Makefile ===
# This file is part of Coccinelle, licensed under the terms of the GPL v2.
# See copyright.txt in the Coccinelle source code for more information.
# The Coccinelle source code can be obtained at http://coccinelle.lip6.fr

#note: if you add a file (a .mli or .ml), don't forget to do a   make depend

ifneq ($(MAKECMDGOALS),distclean)
include ../Makefile.config
-include ../Makefile.local
endif

TARGET = popl

OCAMLCFLAGS ?= -g
OPTFLAGS ?= -g

SRC = ast_popl.ml asttopopl.ml insert_quantifiers.ml insert_befaft.ml \
pretty_print_popl.ml popltoctl.ml popl.ml flag_popl.ml

SYSLIBS=str.cma unix.cma
LIBS=../commons/commons.cma ../globals/globals.cma

INCLUDE_PATH = -I ../commons -I ../globals \
	       -I ../ctl -I ../parsing_c -I ../parsing_cocci -I ../engine

#The Caml compilers.
#for warning:  -w A
#for profiling:  -p -inline 0   with OCAMLOPT
OCAMLC_CMD=$(OCAMLC) $(OCAMLCFLAGS)
OCAMLOPT_CMD=$(OCAMLOPT) $(OPTFLAGS)
OCAMLDEP_CMD=$(OCAMLDEP)
OCAMLMKTOP_CMD=$(OCAMLMKTOP) -g -custom

LIB=$(TARGET).cma
OPTLIB=$(LIB:.cma=.cmxa)

OBJS = $(SRC:.ml=.cmo)
OPTOBJS = $(SRC:.ml=.cmx)

all: $(LIB)
all.opt:
	@$(MAKE) $(OPTLIB) BUILD_OPT=yes

$(TARGET).top: $(LIB)
	$(OCAMLMKTOP_CMD) -o $(TARGET).top $(SYSLIBS) $(LIBS) $(OBJS)

$(LIB):  $(OBJS)
	$(OCAMLC_CMD) -a -o $(LIB) $(OBJS)

clean::
	rm -f $(LIB) $(TARGET).top


$(OPTLIB): $(OPTOBJS)
	$(OCAMLOPT_CMD) -a -o $(OPTLIB) $(OPTOBJS)

# clean rule for LIB.opt
clean::
	rm -f $(OPTLIB) $(LIB:.cma=.a)


.SUFFIXES:
.SUFFIXES: .ml .mli .cmo .cmi .cmx

.ml.cmo:
	$(OCAMLC_CMD) $(INCLUDE_PATH) -c $<

.mli.cmi:
	$(OCAMLC_CMD) $(INCLUDE_PATH) -c $<

.ml.cmx:
	$(OCAMLOPT_CMD) $(INCLUDE_PATH) -c $<


# clean rule for others files
clean::
	rm -f *.cm[iox] *.o *.annot
	rm -f *~ .*~ #*#
	rm -f .depend

distclean: clean

.PHONY: depend
.depend depend:
	$(OCAMLDEP_CMD) $(INCLUDE_PATH) *.mli *.ml > .depend

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
-include .depend
endif
endif

include ../Makefile.common

=== tools/Makefile ===
# This file is part of Coccinelle, licensed under the terms of the GPL v2.
# See copyright.txt in the Coccinelle source code for more information.
# The Coccinelle source code can be obtained at http://coccinelle.lip6.fr

ifneq ($(MAKECMDGOALS),distclean)
include ../Makefile.config
-include ../Makefile.local
endif

OCAMLCFLAGS ?= -g
OPTFLAGS ?= -g

SYSLIBS = str.cma unix.cma bigarray.cma

INCLUDE=-I ../commons -I ../extra -I  ../parsing_c
LIBS=../commons/commons.cma ../globals/globals.cma \
     ../parsing_c/parsing_c.cma ../extra/extra.cma

OCAMLC_CMD=$(OCAMLC) $(OCAMLCFLAGS) $(INCLUDE)
OCAMLOPT_CMD=$(OCAMLOPT) $(OPTFLAGS) $(INCLUDE)
OCAMLDEP_CMD=$(OCAMLDEP) $(INCLUDE)
OCAMLMKTOP_CMD=$(OCAMLMKTOP) -g -custom $(INCLUDE)
OCAMLYACC_CMD=$(OCAMLYACC) -v


PROGS=spp gitgrep splitpatch extract_c_and_res \
	gitsort alloc_free bridge \
	process_isoprofile
	#generate_dependencies

all: $(PROGS)

all.opt:
	@$(MAKE) $(PROGS) BUILD_OPT=yes

gitgrep: gitgrep.ml
	$(OCAMLOPT) -o gitgrep str.cmxa gitgrep.ml

gitsort: gitsort.ml
	$(OCAMLOPT) -o gitsort str.cmxa gitsort.ml

process_isoprofile: process_isoprofile.ml
	$(OCAMLC) -g -o process_isoprofile str.cma process_isoprofile.ml

alloc_free: alloc_free.ml
	$(OCAMLOPT) -o alloc_free str.cmxa alloc_free.ml

# more flexible version of alloc_free
bridge: bridge.ml
	$(OCAMLOPT) -o bridge str.cmxa dumper.mli dumper.ml bridge.ml

install_bridge: bridge
	cp -f bridge /usr/local/bin

spp: spp.ml
	$(OCAMLC_CMD) -o $@ $(SYSLIBS) $(INCLUDE) $(LIBS) $+

splitpatch: splitpatch.cmo
	$(OCAMLC_CMD) -o $@ $(SYSLIBS) $(INCLUDE) $+

extract_c_and_res: extract_c_and_res.cmo
	$(OCAMLC_CMD) -o $@ $(SYSLIBS) $(INCLUDE) $(LIBS)  $+

generate_dependencies: generate_dependencies.cmo
	$(OCAMLC_CMD) -o $@ $(SYSLIBS) $(INCLUDE) $(LIBS)  $+

isoprof: process_isoprofile
	cp process_isoprofile isoprof


.SUFFIXES: .ml .mli .cmo .cmi .cmx

.ml.cmo:
	$(OCAMLC_CMD) -c $<
.mli.cmi:
	$(OCAMLC_CMD) -c $<
.ml.cmx:
	$(OCAMLOPT_CMD) -c $<

clean::
	rm -f *.cm[ioxa] *.o *.a *.cmxa *.annot

distclean: clean
	rm -f $(PROGS) isoprof
	rm -f .depend

.PHONY: depend
.depend depend: beforedepend
	ocamldep $(INCLUDE) *.mli *.ml > .depend

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
-include .depend
endif
endif

include ../Makefile.common

=== demos/spp/Makefile ===
#CFLAGS=-sp_file test.cocci -no_show_diff
CFLAGS=-sp_file test.cocci
#CFLAGS=-sp_file testpy.cocci
CC=../../tools/spp
LD=cat

all: clean test

test: test.o test2.o

test.o: test.c test.h
test2.o: test2.c

clean:
	rm -f test.o test.c.i test2.o test2.c.i

=== docs/manual/Makefile ===
##############################################################################
# Variables
##############################################################################

ifneq ($(MAKECMDGOALS),distclean)
include ../../Makefile.config
-include ../../Makefile.local
endif
HEVEA = hevea
HEVEA_XXDATE := $(shell ./find-xxdate)
HEVEA_CMD := $(HEVEA) -exec $(HEVEA_XXDATE)

MAINSRC=main.tex
SRC=$(wildcard *.tex)
PDFLATEX_CMD=$(PDFLATEX) -halt-on-error
PDF=manual.pdf main_grammar.pdf options.pdf

#tools:
# latex, pdflatex
# xfig
# emacs, auctex, ediff
# darcs
# latexdiff

##############################################################################
# Top rules
##############################################################################
.PHONY: all clean distclean
.SUFFIXES: .pdf .tex

all: pdf html

pdf: $(PDF)

manual.pdf: $(SRC)
	$(PDFLATEX_CMD) manual.tex
	$(PDFLATEX_CMD) manual.tex

main_grammar.pdf: main_grammar.tex cocci_syntax.tex flow1.c flow2.c macros_listing_cocci.tex macros_grammar.tex macros_common.tex examples.tex tips.tex
	#spatch --control-flow-to-file flow1.c
	#spatch --control-flow-to-file flow2.c
	#dot -Gsize="0.5,0.5" -Tpdf flow1:main.dot > flow1.pdf
	#dot -Gsize="0.5,0.5" -Tpdf flow2:main.dot > flow2.pdf
	$(PDFLATEX_CMD) main_grammar.tex
	$(PDFLATEX_CMD) main_grammar.tex

options.pdf: main_options.tex spatch_options.tex   macros_options.tex
	$(PDFLATEX_CMD) options.tex
	$(PDFLATEX_CMD) options.tex

distclean:: clean
	@if test -z "${KEEP_GENERATED}"; then \
		rm -f manual.pdf cocci_syntax.pdf options.pdf; fi


# lindig trick
#RERUN =     Rerun (LaTeX|to get cross-references right)
#
#pdf:	    $(PDF)
#
#%.pdf:	%.tex
#	    $(PDFLATEX) $<
#	    if egrep -s '$(RERUN)' $*.log ;then $(PDFLATEX) $<; fi
#	    if egrep -s '$(RERUN)' $*.log ;then $(PDFLATEX) $<; fi

##############################################################################
# Html version
##############################################################################
.PHONY: html check

.SUFFIXES: .html .tex

TEX=main_grammar.tex
WEBBASE?=~/website
WEBDOCS=$(WEBBASE)/docs

HTML=$(TEX:.tex=.html)

html: $(HTML)

clean::
	rm -f *.aux *.dvi *.pdf *.html *.haux *.htoc *.log *.out *~

distclean:: clean
	@if test -z "${KEEP_GENERATED}"; then \
		rm -f *.pdf *.html *.gif *.css; fi

check: $(HTML)
	checklink $<

.tex.html:
	$(HEVEA_CMD) $<
	$(HEVEA_CMD) $<
	hacha -o index.html main_grammar.html

##############################################################################
# Install
##############################################################################

install: all
	cp *.css *.gif *.html $(WEBDOCS)
	cp $(PDF) $(WEBDOCS)
#	chown apache:apache -R $(WEBDOCS)
#	chmod a-w -R $(WEBDOCS)

##############################################################################
# Developer rules
##############################################################################

LATEXDIFFOPT=--type=CTRADITIONAL

#if multi files ? sed sur les \input{} ? ou create in another dir ?
latexdiff:
	latexdiff $(LATEXDIFFOPT) main-old.tex main.tex > main-diff.tex
	$(MAKE) MAINSRC=main-diff
	rm -f main-diff.aux

replacediff:
	cp main-old.tex main-older.tex
	cp main.tex main-old.tex

clean::
	rm -f main-diff.*

update:

commit:


##############################################################################
# Generic rules
##############################################################################
FORMAT=letter

%.ps: %.dvi
	dvips -P cmz $< -o $@ -t $(FORMAT)

clean::
	rm -f   *.aux \
                *.bbl \
                *.blg \
                *.dvi \
                *.log \
                *.out \
                *.toc

include ../../Makefile.common

=== python/coccilib/Makefile ===
ifneq ($(MAKECMDGOALS),distclean)
include ../../Makefile.config
-include ../../Makefile.local
endif

all:
all.opt:

depend:

clean:
	set -e; for i in $(MAKESUBDIRS); do $(MAKE) -C $$i clean; done
	rm -rf __pycache__
	rm -f *.pyc

distclean: clean

include ../../Makefile.common

=== tools/spgen/Makefile ===
# This file is part of Coccinelle, lincensed under the terms of the GPL v2.
# See copyright.txt in the Coccinelle source code for more information.
# The Coccinelle source code can be obtained at http://coccinelle.lip6.fr

COCCIDIR=../..
-include $(COCCIDIR)/Makefile.config
-include $(COCCIDIR)/Makefile.local

all:
	@$(ECHO) -e "\n\n\tCompiling spgen ...\n\n"
	$(MAKE) -C source all
	@$(ECHO) -e "\n\n\tspgen can now be installed via 'make install'.\n\n"

all.opt:
	@$(ECHO) -e "\n\n\tCompiling spgen in native code...\n\n"
	$(MAKE) -C source all.opt
	@$(ECHO) -e "\n\n\tThe native code version of spgen can now be installed via 'make install'.\n\n"

# also compile documentation; this is not done by default
world: docs all

clean:
	$(MAKE) -C source clean

	$(MAKE) -C documentation clean

distclean: clean

install:
	$(MAKE) -C source install
	@$(ECHO) -e "\n\n\tspgen installed: DONE!!!\n\n"

uninstall:
	$(MAKE) -C source uninstall
	@$(ECHO) -e "\n\n\tspgen uninstalled: DONE!!!\n\n"

docs:
	$(MAKE) -C documentation docs

depend:
	$(MAKE) -C source depend

=== debian/changelog ===
coccinelle (1.1.1.deb-1build2) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 25 Feb 2022 16:15:37 +0100

coccinelle (1.1.1.deb-1build1) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Jan 2022 17:22:34 +0100

coccinelle (1.1.1.deb-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Bump Standards-Version to 4.6.0
  * Update debian/watch
  * Fix debian/gbp.conf

 -- Stéphane Glondu <glondu@debian.org>  Sat, 04 Dec 2021 17:10:10 +0100

=== debian/control ===
Source: coccinelle
Section: devel
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Emmanuel Arias <eamanu@yaerobi.com>,
 Ralf Treinen <treinen@debian.org>
Build-Depends: debhelper-compat (=13),
 dh-ocaml (>= 1.0.3~),
 dh-python,
 libmenhir-ocaml-dev (>= 20090204.dfsg),
 libparmap-ocaml-dev (>= 1.0~rc4-5~),
 libpcre-ocaml-dev,
 libstdcompat-ocaml-dev,
 libpyml-ocaml-dev,
 menhir (>= 20090204.dfsg),
 ocaml-findlib,
 ocaml-nox (>= 3.11.1-3~),
 pkg-config (>= 0.9.0),
 python3
Build-Depends-Indep:
 texlive-fonts-extra,
 texlive-fonts-recommended,
 texlive-latex-base,
 texlive-latex-extra,
 texlive-latex-recommended
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: http://coccinelle.lip6.fr
Vcs-Git: https://salsa.debian.org/ocaml-team/coccinelle.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/coccinelle

Package: coccinelle
Architecture: any
Depends: libparmap-ocaml,
         ocaml-findlib,
         ${misc:Depends},
         ${ocaml:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Pre-Depends: dpkg (>= 1.17.14)
Suggests: coccinelle-doc, vim-addon-manager
Description: semantic patching tool for C
 Coccinelle is a program matching and transformation tool for C.
 The programmer describes the code to match and the transformation to
 perform as a semantic patch, which looks like a standard patch, but can
 transform multiple files at any number of code sites.

Package: coccinelle-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: coccinelle (<< 1.0.0~rc7.deb-4)
Replaces: coccinelle (<< 1.0.0~rc7.deb-4)
Description: documentation for coccinelle
 Coccinelle is a program matching and transformation tool for C.
 The programmer describes the code to match and the transformation to
 perform as a semantic patch, which looks like a standard patch, but can
 transform multiple files at any number of code sites.
 .
 This package contains examples files and additional documentation in
 PDF format.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

VIM_ADIR = $(CURDIR)/debian/coccinelle/usr/share/vim/addons
VIM_RDIR = $(CURDIR)/debian/coccinelle/usr/share/vim/registry

CONFIG_FLAGS = --prefix=/usr --sysconfdir=/etc --libdir=/usr/lib \
  --enable-ocaml --enable-python

ifeq ($(OCAML_NATDYNLINK),yes)
CONFIG_FLAGS += --enable-opt
else
CONFIG_FLAGS += --disable-opt
endif

# Force pdflatex to use SOURCE_DATE_EPOCH for \today
export FORCE_SOURCE_DATE = 1

%:
	dh $@ --with ocaml,python3,autoreconf

override_dh_auto_configure:
	./configure $(CONFIG_FLAGS)

override_dh_auto_build-indep:
	$(MAKE) -C docs/manual pdf

override_dh_auto_test-arch:
	$(MAKE) check || echo "IGNORING FAILED TESTS"

override_dh_auto_test-indep:
	# nothing

override_dh_auto_install-arch:
	$(MAKE) DESTDIR=$(CURDIR)/debian/coccinelle install install-bash

	# Vim files
	install -d $(VIM_ADIR)/ftdetect $(VIM_ADIR)/syntax
	cp $(CURDIR)/editors/vim/ftdetect/cocci.vim $(VIM_ADIR)/ftdetect/
	cp $(CURDIR)/editors/vim/syntax/cocci.vim $(VIM_ADIR)/syntax/
	install -d $(VIM_RDIR)
	cp $(CURDIR)/debian/coccinelle.yaml $(VIM_RDIR)/

	# Emacs files
	cp $(CURDIR)/editors/emacs/cocci.el $(CURDIR)/debian/coccinelle/usr/share/emacs/site-lisp/

override_dh_auto_install-indep:
	# Nothing

override_dh_compress:
	dh_compress -X.pdf -X.cocci -X.c

=== debian/watch ===
version=4
opts=uversionmangle=s/(.*)/$1\.deb/ \
   https://github.com/coccinelle/coccinelle/tags .*/([0-9.]+)\.tar\.gz

## coccinelle 1.2.deb

=== Makefile ===
ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
ifeq ($(wildcard Makefile.config),)
ifeq ($(wildcard configure),)
$(error To make coccinelle, please run ./autogen and ./configure first)
else
$(error To make coccinelle, please run ./configure first)
endif
else
include Makefile.libs
include Makefile.config
endif
endif
endif
-include Makefile.local

CORE_LIBRARIES := \
	commons globals parsing_cocci parsing_c
LIBRARIES := \
	$(CORE_LIBRARIES) ctl ocaml python engine popl09 extra

TOOLS := spatch spgen

DEPEND_METHOD := multifile

SOURCES_commons := \
	ocamlextra/dumper.ml commands.ml common.ml ograph_simple.ml \
	ograph_extended.ml
SOURCES_globals := \
	config.ml flag.ml iteration.ml $(REGEXP_FILE) regexp.ml
CLEAN_globals := regexp_pcre.ml regexp_str.ml
SOURCES_ctl := \
	flag_ctl.ml ast_ctl.ml pretty_print_ctl.ml ctl_engine.ml wrapper_ctl.ml
SOURCES_parsing_cocci := \
	flag_parsing_cocci.ml ast_cocci.ml ast0_cocci.ml \
	pretty_print_cocci.ml visitor_ast0_types.ml \
	visitor_ast.ml visitor_ast0.ml ast0toast.ml unparse_ast0.ml \
	unify_ast.ml compute_lines.ml iso_pattern.ml comm_assoc.ml \
	iso_compile.ml single_statement.ml simple_assignments.ml \
	get_metas.ml stmtlist.ml top_level.ml \
	type_infer.ml test_exps.ml unitary_ast0.ml arity.ml index.ml \
	context_neg.ml adjust_pragmas.ml insert_plus.ml function_prototypes.ml \
	semantic_cocci.ml data.ml free_vars.ml check_meta.ml safe_for_multi_decls.ml \
	parse_printf.ml parse_aux.ml cleanup_rules.ml disjdistr.ml \
	parser_cocci_menhir.mly lexer_cocci.mll \
	lexer_cli.mll lexer_script.mll \
	cocci_grep.ml dpll.ml get_constants2.ml id_utils.ml git_grep.ml patch_diff.ml \
	adjacency.ml commas_on_lists.ml re_constraints.ml parse_cocci.ml \
	command_line.ml cocci_args.ml
SOURCES_parsing_c := \
	token_annot.ml flag_parsing_c.ml parsing_stat.ml \
	token_c.ml ast_c.ml includes.ml control_flow_c.ml \
	visitor_c.ml lib_parsing_c.ml includes_cache.ml pretty_print_c.ml \
	control_flow_c_build.ml semantic_c.ml lexer_parser.ml parser_c.mly \
	lexer_c.mll parse_string_c.ml token_helpers.ml token_views_c.ml \
	cpp_token_c.ml parsing_hacks.ml cpp_analysis_c.ml \
	unparse_cocci.ml parsing_recovery_c.ml parsing_consistency_c.ml \
	danger.ml parse_c.ml unparse_c.ml unparse_hrule.ml \
	type_c.ml cpp_ast_c.ml \
	type_annoter_c.ml comment_annotater_c.ml \
	compare_c.ml test_parsing_c.ml
SOURCES_ocaml := \
	externalanalysis.ml \
	exposed_modules.ml coccilib.ml ocamlcocci_aux.ml $(OCAMLCOCCI_FILE) \
	prepare_ocamlcocci.ml run_ocamlcocci.ml
CLEAN_ocaml := yes_prepare_ocamlcocci.ml no_prepare_ocamlcocci.ml
SOURCES_python := \
	pycocci_aux.ml $(PYCOCCI_FILE) pycocci.ml
CLEAN_python := yes_pycocci.ml no_pycocci.ml
SOURCES_engine := \
	flag_matcher.ml lib_engine.ml pretty_print_engine.ml \
	check_exhaustive_pattern.ml \
	check_reachability.ml \
	c_vs_c.ml isomorphisms_c_c.ml \
	cocci_vs_c.ml pattern_c.ml transformation_c.ml \
	asttomember.ml asttoctl2.ml ctltotex.ml \
	postprocess_transinfo.ml ctlcocci_integration.ml
SOURCES_popl09 := \
	ast_popl.ml asttopopl.ml insert_quantifiers.ml \
	pretty_print_popl.ml flag_popl.ml popltoctl.ml popl.ml
SOURCES_extra := \
	classic_patch.ml kbuild.ml maintainers.ml

SOURCES_library := \
	flag_cocci.ml cocci.ml testing.ml read_options.ml enter.ml

SOURCES_spatch := \
	$(SOURCES_library) main.ml

SOURCES_spgen := \
	globals.ml ast_tostring.ml detect_patch.ml meta_variable.ml \
	snapshot.ml user_input.ml position_generator.ml disj_generator.ml \
	rule_body.ml rule_header.ml context_rule.ml script_rule.ml \
	file_transform.ml spgen_interactive.ml spgen_lexer.mll spgen_config.ml \
	spgen.ml spgen_test.ml main.ml

PREFIX_spatch :=

PREFIX_spgen := tools/spgen/source/

CORE_LIBS := unix str \
	$(STDCOMPATDIR)/stdcompat \
	$(patsubst %,bytes,$(BYTESDIR)) \
	$(patsubst %,pcre,$(filter %/pcre.cma,$(LNKLIBS)))

ifeq ($(OCAMLATLEAST50),no)
CORE_LIBS += bigarray
endif

ifeq ($(FEATURE_OCAML),1)
CORE_LIBS += dynlink
endif

LIBS_spatch := $(CORE_LIBS) \
	$(patsubst %,pyml,$(filter %/pyml.cma,$(LNKLIBS)))\
	$(patsubst %,parmap,$(filter %/parmap.cma,$(LNKLIBS)))

LIBS_spgen := $(CORE_LIBS)

LIBRARIES_spatch := $(LIBRARIES)

LIBRARIES_spgen := $(CORE_LIBRARIES)

CORE_BUNDLES=stdcompat menhirLib pcre

ALL_BUNDLES=$(CORE_BUNDLES) parmap pyml

BUNDLES_spatch=$(ALL_BUNDLES)

BUNDLES_spgen=$(CORE_BUNDLES)

SOURCEFILES :=

define foreach_library
SOURCEFILES_$(library) := $(addprefix $(library)/, $(SOURCES_$(library)))
CLEANFILES_$(library) := $(addprefix $(library)/, $(CLEAN_$(library)))
SOURCEFILES+=$$(SOURCEFILES_$(library))
endef
$(foreach library,$(LIBRARIES),$(eval $(foreach_library)))

define foreach_tool
SOURCEFILES_$(tool) := $(addprefix $(PREFIX_$(tool)), $(SOURCES_$(tool)))
SOURCEFILES+=$$(SOURCEFILES_$(tool))
endef
$(foreach tool,$(TOOLS),$(eval $(foreach_tool)))

ifeq ($(MAKECMDGOALS),opt)
NATIVE := yes
else
ifeq ($(MAKECMDGOALS),opt-only)
NATIVE := yes
else
ifeq ($(MAKECMDGOALS),all.opt)
NATIVE := yes
else
ifeq ($(TARGET_SPATCH),byte-only)
NATIVE := no
else
NATIVE := yes
endif
endif
endif
endif

ifeq ($(NATIVE),yes)
LIBSUFFIX := .cmxa
else
LIBSUFFIX := .cma
endif

ifeq ($(NATIVE),yes)
	TOOLS_SUFFIX := .opt
	ALL_OBJECTS := cmo cmx
else
	TOOLS_SUFFIX :=
	ALL_OBJECTS := cmo
endif

EXPOSED_MODULES := \
	$(shell sed -n 's/^.*(\* \(.*\) \*).*$$/\1/p' ocaml/exposed_modules.ml)

COMPILED_EXPOSED_MODULES := \
	$(foreach EXT,cmi $(ALL_OBJECTS),\
		$(patsubst %,ocaml/%.$(EXT), \
			$(notdir $(basename $(EXPOSED_MODULES)))))

SEARCH_PATHS := \
	commons/ocamlextra $(LIBRARIES) $(PREFIX_spgen) $(PCREDIR) $(PYMLDIR) \
	$(PARMAPDIR) $(BYTESDIR) $(STDCOMPATDIR)

ifneq ($(OCAMLATLEAST50),no)
SEARCH_PATHS += +str +unix +dynlink
endif

SEARCH_PATH_FLAGS := $(addprefix -I ,$(SEARCH_PATHS))

CCLIB := $(patsubst %,-cclib -lparmap_stubs,$(filter %/parmap.cma,$(LNKLIBS))) \
	-cclib -L.

OCAMLC_CMD := $(OCAMLC) $(SEARCH_PATH_FLAGS) $(CCLIB) $(EXTRA_OCAML_FLAGS)

OCAMLOPT_CMD := $(OCAMLOPT) $(SEARCH_PATH_FLAGS) $(CCLIB) $(EXTRA_OCAML_FLAGS)

OCAMLDEP_CMD := $(OCAMLDEP) $(SEARCH_PATH_FLAGS) \
	$(addprefix -ml-synonym ,.mll .mly) \
	$(addprefix -mli-synonym ,.ml .mll .mly)

MENHIR_DEP_CMD := $(MENHIR) --ocamldep "$(OCAMLDEP_CMD)" --depend

MENHIR_CMD := $(MENHIR) $(MENHIR_FLAGS) --ocamlc "$(OCAMLC_CMD)" --explain --infer

MENHIR_LIB := \
	$(addsuffix /menhirLib$(LIBSUFFIX),$(filter %/menhirLib,$(MAKELIBS)))
PARMAP_LIB := $(addsuffix /parmap$(LIBSUFFIX),$(filter %/parmap,$(MAKELIBS)))
PYML_LIB := $(addsuffix /pyml$(LIBSUFFIX),$(filter %/pyml,$(MAKELIBS)))
PCRE_LIB := $(addsuffix /pcre$(LIBSUFFIX),$(filter %/pcre,$(MAKELIBS)))
STDCOMPAT_LIB := $(STDCOMPATDIR)/stdcompat$(LIBSUFFIX)

STDCOMPAT_USERS := parsing_c/type_annoter_c cocci parsing_cocci/check_meta \
	parsing_cocci/id_utils parsing_cocci/insert_plus \
	parsing_cocci/lexer_cocci ocaml/yes_prepare_ocamlcocci \
	tools/spgen/source/user_input tools/spgen/source/spgen_interactive \
	parsing_c/flag_parsing_c commons/common parsing_cocci/cocci_args

SHOW_CLEAN := @echo "CLEAN    "
SHOW_OCAMLC := @echo "OCAMLC   "
SHOW_OCAMLOPT := @echo "OCAMLOPT "

ifeq ($(VERBOSE),yes)
RUN_OCAMLDEP = $(OCAMLDEP_CMD)
RUN_OCAMLC = $(OCAMLC_CMD)
RUN_OCAMLC_O = $(OCAMLC_CMD)
RUN_OCAMLOPT = $(OCAMLOPT_CMD)
RUN_OCAMLOPT_O = $(OCAMLOPT_CMD)
RUN_MENHIR = $(MENHIR_CMD)
RUN_OCAMLLEX = $(OCAMLLEX)
RUN_OCAMLYACC = $(OCAMLYACC)
else
RUN_OCAMLDEP = @echo "OCAMLDEP  $<"; $(OCAMLDEP_CMD)
RUN_OCAMLC = $(SHOW_OCAMLC) "$<"; $(OCAMLC_CMD)
RUN_OCAMLC_O = $(SHOW_OCAMLC) "-o $@"; $(OCAMLC_CMD)
RUN_OCAMLOPT = $(SHOW_OCAMLOPT) "$<"; $(OCAMLOPT_CMD)
RUN_OCAMLOPT_O = $(SHOW_OCAMLOPT) "-o $@"; $(OCAMLOPT_CMD)
RUN_MENHIR = @echo "MENHIR    $<"; $(MENHIR_CMD)
RUN_OCAMLLEX = @echo "OCAMLLEX  $<"; $(OCAMLLEX)
RUN_OCAMLYACC = @echo "OCAMLYACC $<"; $(OCAMLYACC)
endif

MKDIR_P := mkdir -p

include Makefile.package

.PHONY : all
all : \
	$(foreach tool,$(TOOLS),$(PREFIX_$(tool))$(tool)$(TOOLS_SUFFIX)) \
	exposed-modules

.PHONY : all-dev
all-dev : byte-only exposed-modules

.PHONY : all.opt
all.opt : opt-only exposed-modules

.PHONY : all-release
all-release : all.opt docs

.PHONY : world
world :  byte-only opt-only exposed-modules docs

.PHONY : exposed-modules
exposed-modules : $(COMPILED_EXPOSED_MODULES) ocaml/parmap.cmi

.PHONY : check
check : spatch$(TOOLS_SUFFIX)
	./spatch$(TOOLS_SUFFIX) --testall

.PHONY : clean
clean :
	$(SHOW_CLEAN) ".depend"
	@rm -f .depend

.PHONY : distclean
distclean : clean
	$(SHOW_CLEAN) "configure"
	@rm -f configure Makefile.config

.PHONY : opt-only opt
opt-only opt : $(foreach tool,$(TOOLS),$(PREFIX_$(tool))$(tool).opt)

.PHONY : byt-only byte-only byte
byt-only byte-only byte : $(foreach tool,$(TOOLS),$(PREFIX_$(tool))$(tool))

.PHONY: install
install: install-spatch install-spgen install-python install-bash install-man

.PHONY: install-bash
install-bash:
	if test "x$(BASH_COMPLETION_DIR)" != "xno"; then \
		$(MKDIR_P) $(DESTDIR)$(BASH_COMPLETION_DIR); \
		$(INSTALL_DATA) scripts/spatch.bash_completion \
			$(DESTDIR)$(BASH_COMPLETION_DIR)/spatch; \
	fi

.PHONY: install-spatch
install-spatch : spatch$(TOOLS_SUFFIX)
	$(MKDIR_P) $(DESTDIR)$(BINDIR) $(DESTDIR)$(LIBDIR)
	$(MKDIR_P) $(DESTDIR)$(LIBDIR)/ocaml
	if test -f bundles/pyml/dllpyml_stubs.so; then \
		$(INSTALL_PROGRAM) bundles/pyml/dllpyml_stubs.so \
			$(DESTDIR)$(LIBDIR); \
	fi
	if test -f bundles/pcre/dllpcre_stubs.so; then \
		$(INSTALL_PROGRAM) bundles/pcre/dllpcre_stubs.so \
			$(DESTDIR)$(LIBDIR); \
	fi
	$(INSTALL_PROGRAM) spatch$(TOOLS_SUFFIX) $(DESTDIR)$(BINDIR)/spatch
	$(INSTALL_DATA) standard.h $(DESTDIR)$(LIBDIR)
	$(INSTALL_DATA) standard.iso $(DESTDIR)$(LIBDIR)
	$(INSTALL_DATA) ocaml/*.cmi $(DESTDIR)$(LIBDIR)/ocaml/
	if test -f ocaml/coccilib.cmx; then \
		$(INSTALL_DATA) ocaml/*.cmx $(DESTDIR)$(LIBDIR)/ocaml/; \
	fi

.PHONY : install-man
install-man :
	$(MKDIR_P) $(DESTDIR)$(MANDIR)/man1
	$(MKDIR_P) $(DESTDIR)$(MANDIR)/man3
	$(INSTALL_DATA) docs/spatch.1 $(DESTDIR)$(MANDIR)/man1/
	$(INSTALL_DATA) docs/pycocci.1 $(DESTDIR)$(MANDIR)/man1/
	$(INSTALL_DATA) docs/spgen.1 $(DESTDIR)$(MANDIR)/man1/
	$(INSTALL_DATA) docs/Coccilib.3cocci $(DESTDIR)$(MANDIR)/man3/

.PHONY : install-spgen
install-spgen : tools/spgen/source/spgen$(TOOLS_SUFFIX)
	$(INSTALL_PROGRAM) tools/spgen/source/spgen$(TOOLS_SUFFIX) \
		 $(DESTDIR)$(BINDIR)/spgen

.PHONY : install-python
install-python:
	$(MKDIR_P) $(DESTDIR)$(LIBDIR)/python/coccilib
	$(INSTALL_DATA) python/coccilib/*.py \
		$(DESTDIR)$(LIBDIR)/python/coccilib

.PHONY : uninstall
uninstall : uninstall-bash
	rm -f $(DESTDIR)$(BINDIR)/spatch
	rm -f $(DESTDIR)$(BINDIR)/spatch.opt
	rm -f $(DESTDIR)$(BINDIR)/spatch.byte

.PHONY : uninstall-bash
uninstall-bash :
	rm -f $(DESTDIR)$(BASH_COMPLETION_DIR)/spatch
	rmdir --ignore-fail-on-non-empty -p \
		$(DESTDIR)$(BASH_COMPLETION_DIR)

ml_files_but_parsers := \
	$(filter %.ml,$(SOURCEFILES)) \
	$(patsubst %.mll,%.ml,$(filter %.mll,$(SOURCEFILES)))

.PHONY : docs
docs :
	-$(MAKE) -C docs
	-$(MAKE) docs -C tools/spgen/documentation

.PHONY : mlis
mlis : $(patsubst %.ml,%.mli,$(ml_files_but_parsers))

define foreach_ml_files_but_parsers
ifeq ($(wildcard $(sourcefile:.ml=.mli)),)
$(sourcefile:.ml=.mli) : $(sourcefile)
	$(OCAMLC_CMD) -i $$< >$$@ || (rm $$@; false)
endif
endef
#$(foreach sourcefile,$(ml_files_but_parsers),\
#	$(eval $(foreach_ml_files_but_parsers)))

%.ml.d : %.ml
	$(RUN_OCAMLDEP) $< >$@ || (rm $@; false)

%.mli.d : %.mli
	$(RUN_OCAMLDEP) $< >$@ || (rm $@; false)

%.ml : %.mll
	$(RUN_OCAMLLEX) $<

ml_files_but_menhir := $(ml_files_but_parsers) parsing_c/parser_c.ml
ml_files := $(ml_files_but_menhir) parsing_cocci/parser_cocci_menhir.ml coccinelle.ml
ml_and_mli_files_but_menhir := $(ml_files_but_menhir) $(ml_files_but_menhir:.ml=.mli)

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
ifeq ($(DEPEND_METHOD),onefile)
.depend : $(ml_and_mli_files_but_menhir) parsing_cocci/parser_cocci_menhir.mly $(MENHIR)
	@echo OCAMLDEP .depend
	@$(OCAMLDEP_CMD) $(ml_and_mli_files_but_menhir) >$@ || (rm $@; false)

=== debian/changelog ===
coccinelle (1.2.deb-1build1) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 09 Aug 2024 14:29:45 +0200

coccinelle (1.2.deb-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sat, 13 Jul 2024 14:01:27 +0200

coccinelle (1.1.1.deb-6) unstable; urgency=medium

  * Team upload
  * Fix build with OCaml 5.2.0

 -- Stéphane Glondu <glondu@debian.org>  Sat, 29 Jun 2024 08:50:49 +0200

coccinelle (1.1.1.deb-5) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload

  [ Bastian Germann ]
  * Drop pcre support (Closes: #1050620)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 27 Aug 2023 19:32:03 +0200

coccinelle (1.1.1.deb-4) unstable; urgency=medium

  * Team upload
  * Disable native code compilation on armhf (Closes: #1049958) and
    riscv64

 -- Stéphane Glondu <glondu@debian.org>  Thu, 17 Aug 2023 13:35:00 +0200

coccinelle (1.1.1.deb-3) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Bump Standards-Version to 4.6.2

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on dh-ocaml (>= 1.0.3~).
    + Build-Depends: Drop versioned constraint on libmenhir-ocaml-dev (>=
      20090204.dfsg).
    + Build-Depends: Drop versioned constraint on libparmap-ocaml-dev (>=
      1.0~rc4-5~).
    + Build-Depends: Drop versioned constraint on menhir (>= 20090204.dfsg).
    + Build-Depends: Drop versioned constraint on ocaml-nox (>= 3.11.1-3~).
    + Build-Depends: Drop versioned constraint on pkg-config (>= 0.9.0).
    + coccinelle: Drop dependency on essential package dpkg (>= 1.17.14) in
      Pre-Depends.
    + coccinelle-doc: Drop conflict with removed package coccinelle (<<
      1.0.0~rc7.deb-4) in Replaces.
    + coccinelle-doc: Drop conflict with removed package coccinelle (<<
      1.0.0~rc7.deb-4) in Breaks.
    + Remove 1 maintscript entries from 1 files.

 -- Stéphane Glondu <glondu@debian.org>  Tue, 08 Aug 2023 09:26:45 +0200

coccinelle (1.1.1.deb-2) unstable; urgency=medium

  * d/rules: force configuration for python3. Thanks to Uwe Kleine-König
    for the patch (closes: #1023653).
  * Standards-Version 4.6.1 (no change)

 -- Ralf Treinen <treinen@debian.org>  Thu, 10 Nov 2022 11:21:48 +0100

=== debian/control ===
--- 
+++ 
@@ -4,26 +4,26 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Emmanuel Arias <eamanu@yaerobi.com>,
  Ralf Treinen <treinen@debian.org>
-Build-Depends: debhelper-compat (=13),
- dh-ocaml (>= 1.0.3~),
+Build-Depends: debhelper-compat (= 13),
+ dh-ocaml,
  dh-python,
- libmenhir-ocaml-dev (>= 20090204.dfsg),
- libparmap-ocaml-dev (>= 1.0~rc4-5~),
- libpcre-ocaml-dev,
+ libmenhir-ocaml-dev,
+ libparmap-ocaml-dev,
  libstdcompat-ocaml-dev,
  libpyml-ocaml-dev,
- menhir (>= 20090204.dfsg),
+ menhir,
  ocaml-findlib,
- ocaml-nox (>= 3.11.1-3~),
- pkg-config (>= 0.9.0),
+ ocaml,
+ pkgconf,
  python3
 Build-Depends-Indep:
+ hevea,
  texlive-fonts-extra,
  texlive-fonts-recommended,
  texlive-latex-base,
  texlive-latex-extra,
  texlive-latex-recommended
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: http://coccinelle.lip6.fr
 Vcs-Git: https://salsa.debian.org/ocaml-team/coccinelle.git
@@ -37,7 +37,6 @@
          ${ocaml:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
-Pre-Depends: dpkg (>= 1.17.14)
 Suggests: coccinelle-doc, vim-addon-manager
 Description: semantic patching tool for C
  Coccinelle is a program matching and transformation tool for C.
@@ -50,8 +49,6 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
-Breaks: coccinelle (<< 1.0.0~rc7.deb-4)
-Replaces: coccinelle (<< 1.0.0~rc7.deb-4)
 Description: documentation for coccinelle
  Coccinelle is a program matching and transformation tool for C.
  The programmer describes the code to match and the transformation to

## coccinelle 1.3.0.deb

=== Makefile ===
--- 
+++ 
@@ -27,7 +27,7 @@
 	ocamlextra/dumper.ml commands.ml common.ml ograph_simple.ml \
 	ograph_extended.ml
 SOURCES_globals := \
-	config.ml flag.ml iteration.ml $(REGEXP_FILE) regexp.ml
+	cocciconfig.ml flag.ml iteration.ml $(REGEXP_FILE) regexp.ml
 CLEAN_globals := regexp_pcre.ml regexp_str.ml
 SOURCES_ctl := \
 	flag_ctl.ml ast_ctl.ml pretty_print_ctl.ml ctl_engine.ml wrapper_ctl.ml
@@ -98,7 +98,7 @@
 
 PREFIX_spgen := tools/spgen/source/
 
-CORE_LIBS := unix str \
+CORE_LIBS := unix str ocamlcommon \
 	$(STDCOMPATDIR)/stdcompat \
 	$(patsubst %,bytes,$(BYTESDIR)) \
 	$(patsubst %,pcre,$(filter %/pcre.cma,$(LNKLIBS)))
@@ -191,6 +191,7 @@
 ifneq ($(OCAMLATLEAST50),no)
 SEARCH_PATHS += +str +unix +dynlink
 endif
+SEARCH_PATHS += +compiler-libs
 
 SEARCH_PATH_FLAGS := $(addprefix -I ,$(SEARCH_PATHS))
 
@@ -273,6 +274,14 @@
 .PHONY : check
 check : spatch$(TOOLS_SUFFIX)
 	./spatch$(TOOLS_SUFFIX) --testall
+
+.PHONY : check-cpp
+check-cpp:
+	cd cpptests && ../scripts/cpptests.sh
+
+.PHONY : check-cpp-html
+check-cpp-html:
+	cd cpptests && ../scripts/cpptests.sh -o cpptests.html
 
 .PHONY : clean
 clean :
@@ -390,6 +399,3 @@
 ifneq ($(MAKECMDGOALS),clean)
 ifneq ($(MAKECMDGOALS),distclean)
 ifeq ($(DEPEND_METHOD),onefile)
-.depend : $(ml_and_mli_files_but_menhir) parsing_cocci/parser_cocci_menhir.mly $(MENHIR)
-	@echo OCAMLDEP .depend
-	@$(OCAMLDEP_CMD) $(ml_and_mli_files_but_menhir) >$@ || (rm $@; false)

=== commons/Makefile ===
LIBRARY=commons

include ../Makefile.library

=== engine/Makefile ===
LIBRARY=engine

include ../Makefile.library

=== globals/Makefile ===
LIBRARY=globals

include ../Makefile.library

=== ocaml/Makefile ===
LIBRARY=ocaml

include ../Makefile.library

=== python/Makefile ===
LIBRARY=python

include ../Makefile.library

=== docs/manual/Makefile ===
--- 
+++ 
@@ -8,6 +8,9 @@
 endif
 HEVEA = hevea
 HEVEA_XXDATE := $(shell ./find-xxdate)
+
+$(if $(HEVEA_XXDATE),,$(error Hevea: Unable to find xxdate.exe))
+
 HEVEA_CMD := $(HEVEA) -exec $(HEVEA_XXDATE)
 
 MAINSRC=main.tex

=== editors/vim/Makefile ===
DATE = $(shell date +%Y%m%d)

all: cocci-syntax-$(DATE).tar.bz2

cocci-syntax-$(DATE).tar.bz2:
	git archive --prefix=cocci-syntax-$(DATE)/ HEAD | tar --delete cocci-syntax-$(DATE)/.gitignore cocci-syntax-$(DATE)/Makefile | bzip2 -c > $@

clean:
	rm -rf *.tar.bz2 *.tar || true

upload: cocci-syntax-$(DATE).tar.bz2
	scp $< dev.exherbo.org:public_html/pub/software/releases/cocci-syntax/

install:
	@mkdir -p ~/.vim/ftdetect/
	@mkdir -p ~/.vim/syntax/
	cp ftdetect/cocci.vim ~/.vim/ftdetect/
	cp syntax/cocci.vim ~/.vim/syntax/

.phony: clean upload install

.default: all

=== tools/spgen/documentation/Makefile ===
# This file is part of Coccinelle, lincensed under the terms of the GPL v2.
# See copyright.txt in the Coccinelle source code for more information.
# The Coccinelle source code can be obtained at http://coccinelle.lip6.fr

# A fairly minimal-effort rule for compiling the documentation.
# Requires a few standard LaTeX packages.

ifneq ($(MAKECMDGOALS),distclean)
ifneq ($(MAKECMDGOALS),clean)
include ../../../Makefile.config
-include ../../../Makefile.local
endif
endif


sources := $(wildcard *.tex)

manual := documentation.pdf

PDFLATEX_CMD=$(PDFLATEX) -halt-on-error

docs: $(manual)

$(manual): $(sources)
	$(PDFLATEX_CMD) documentation.tex
	$(PDFLATEX_CMD) documentation.tex

clean:
	rm -f *.aux *.log *.out *.toc *.pdf *.dvi *.ps *~

=== tools/spgen/source/Makefile ===
.PHONY : all
all : spgen

.PHONY : all.opt
all.opt : spgen.opt

.PHONY : clean
clean :
	$(MAKE) -C../../.. clean-spgen

spgen :
	$(MAKE) -C../../.. tools/spgen/source/spgen

spgen.opt :
	$(MAKE) -C../../.. tools/spgen/source/spgen.opt

=== debian/changelog ===
coccinelle (1.3.0.deb-1build2) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 29 Jan 2025 14:11:54 +0100

coccinelle (1.3.0.deb-1build1) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 23 Jan 2025 09:06:22 +0100

coccinelle (1.3.0.deb-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches dont-expose-parmap and dont-update-test-score
  * Do not build the coccinelle-doc package (closes: #1087437)
    - debian/control: disable this package, and the build-depend-indeps
    - debian/rules: disable override_dh_auto_build-indep
  * Standards-Version 4.7.0 (no change)

 -- Ralf Treinen <treinen@debian.org>  Sun, 19 Jan 2025 19:39:32 +0100

=== debian/rules ===
--- 
+++ 
@@ -9,9 +9,15 @@
 VIM_RDIR = $(CURDIR)/debian/coccinelle/usr/share/vim/registry
 
 CONFIG_FLAGS = --prefix=/usr --sysconfdir=/etc --libdir=/usr/lib \
-  --enable-ocaml --enable-python
+  --enable-ocaml --enable-python --with-python=python3
 
-ifeq ($(OCAML_NATDYNLINK),yes)
+ifeq ($(DEB_BUILD_ARCH),armhf)
+# Native code uses too much memory, see #1049958
+CONFIG_FLAGS += --disable-opt
+else ifeq ($(DEB_BUILD_ARCH),riscv64)
+# Native code compilation segfaults
+CONFIG_FLAGS += --disable-opt
+else ifeq ($(OCAML_NATDYNLINK),yes)
 CONFIG_FLAGS += --enable-opt
 else
 CONFIG_FLAGS += --disable-opt
@@ -26,8 +32,8 @@
 override_dh_auto_configure:
 	./configure $(CONFIG_FLAGS)
 
-override_dh_auto_build-indep:
-	$(MAKE) -C docs/manual pdf
+# override_dh_auto_build-indep:
+#	$(MAKE) -C docs/manual pdf
 
 override_dh_auto_test-arch:
 	$(MAKE) check || echo "IGNORING FAILED TESTS"
